/****
 * CKeyWindow.h
 *
 *	Document class for SignWriter.
 *
 *  Copyright  1996 The Center for Sutton Movement Writing.  All rights reserved.
 *
 ****/

#pragma once	

#include <CDirector.h>
#include <CApplication.h>
#include "CKeyWndKeys.h"
#include "CKeyWndBox.h"




struct CKeyWindow : CDirector {


	CKeyWndKeys		*itsKeyPanes;		// keyboard display
	
	CKeyWndBox		*itsCurKeyPane;		// current key indicator
	CKeyWndBox		*itsCurKbdPane;		// current keyboard indicator
	

	  
    void        	IKeyWindow(CApplication *aSupervisor, Boolean printable);
    void        	Dispose(void);

	void			DoCommand(long theCommand);
	void			DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);

    void        	UpdateMenus(void);  

	void			NewFile(void);
	void			OpenFile(SFReply *macSFReply);
	void			UpdateFile(void);

	void  		  	BuildWindow(void);
	void  		 	BuildSymWindow(void);

	Boolean		  	DoSave(void);
	Boolean		  	DoSaveAs(SFReply *macSFReply);
	void		  	DoRevert(void);
	
	Boolean		 	Close(Boolean quitting);
	

};