/******************************************************************************
 UpdateFile.c

		Update File callbacks for the SignWriter key editor
		
		Copyright  1996 Center for Sutton Movement Writing. All rights reserved.

 ******************************************************************************/
 
 
 
 
 #include "UpdateFile.h"
 #include <Controls.h>
 #include <Files.h>
 #include "KeyEditConsts.h"
 #include <OSUtils.h>
 #include <StandardFile.h>
 



/*** Global Variables ***/

extern	Str63	gFileName;		/* Current key file name */




/***
 * UpdateFileHook
 *
 *	Use the dialog hook to change the standard
 *  file dialog's 'Open' button to 'Update'
 *  for the Update Sign Keyboard command. 
 *
 ***/
 
pascal short UpdateFileHook (short item, DialogPtr dlog)

{
	Str15	cTitle = UPDATE_NAME;
	short	iType;
	Handle	iHandle;
	Rect	iRect;

	
	if (item == sfHookFirstCall) {
	
		GetDItem(dlog, getOpen, &iType, &iHandle, &iRect);
		SetCTitle(iHandle, CtoPstr(cTitle));
		
	}
	
	return item;
}



/***
 * UpdateFileFilter
 *
 *	Use the dialog filter to hide the
 *  name of the currently open key file.
 *
 ***/

pascal Boolean UpdateFileFilter (fileParam* thePB)

{
	return EqualString(thePB->ioNamePtr, gFileName, FALSE, FALSE);
}

