

///////////////////////////////////////////////////////////////////////
//
//	  Convert SignWriter 4.3 PC symbol file to SW 5.0 Mac format
//
///////////////////////////////////////////////////////////////////////



#include <stdio.h>
#include <stdlib.h>
#include "Symbols.h"
#include "SymEditConsts.h"



#define SYMBUF_SIZE		64000
	
Handle	symBuf;


void	IOCheck   (short result, short requested);
void	FlipBytes (short *value);
void	ReadOld   (void);
void	WriteNew  (void);




void IOCheck (short result, short requested)

{
	if (result < requested) {
		printf("*** File I/O error ***\n");
		exit(0);
	}
}
	
	

void FlipBytes (short *value)

{
	Byte	src[2];
	Byte	dest[2];
	
	BlockMove(value, &src, 2);

	dest[0] = src[1];
	dest[1] = src[0];
	
	BlockMove(&dest, value, 2);
}
	


void ReadOld()

{
	FILE			*oldFile;	
	short			bytesRead;
	short			symCode;
	short	 		symSize[256];
	short	 		chrSize[256];
	short	 		symAttr[256];

	
	oldFile = fopen("sw.sym", "rb");

	bytesRead = fread(*symBuf, 512, 1, oldFile); 		// skip header info
	IOCheck(bytesRead, 1);
	
	bytesRead = fread(chrSize, 512, 1, oldFile); 		// get chr img sizes
	IOCheck(bytesRead, 1);

	bytesRead = fread(symSize, 512, 1, oldFile); 		// get sym img sizes
	IOCheck(bytesRead, 1);

	bytesRead = fread(symAttr, 512, 1, oldFile); 		// get sym attributes
	IOCheck(bytesRead, 1);
	
	
	for (symCode = 0; symCode < 256; symCode++) {		// PC -> Mac sex change
	
		FlipBytes(&chrSize[symCode]);
		FlipBytes(&symSize[symCode]);
		FlipBytes(&symAttr[symCode]);
	}
	
	
	for (symCode = 0; symCode < 256; symCode++) {		// skip PC char images
		
		bytesRead = fread(*symBuf, 1, chrSize[symCode], oldFile);
		IOCheck(bytesRead, chrSize[symCode]);
			
	}	
	
	
	for (symCode = 0; symCode < 250; symCode++) {		// get PC sym images
		
		/**
		 **	Read symbol bytes into buffer and then
		 **	unpack them into SymEdit's internal data structure.
		 **
		 **/
		 
		bytesRead = fread(*symBuf, 1, symSize[symCode], oldFile);
		IOCheck(bytesRead, symSize[symCode]);
		

		/**
		 ** Shift symbols from 0-based to 1-based
		 **
		 **/
		 
		UnpackSymbol(symCode + 1, symBuf, symSize[symCode], symAttr[symCode]);
		
		printf("Symbol %d unpacked\n", symCode);
					
	}	
	 
	fclose(oldFile);	

}



void WriteNew (void)

{	
	FILE			*newFile;	
	short			bytesWritten;
	short			symCode;
	unsigned short  symBytes;
	
	
	newFile = fopen("SignWriter Symbols", "wb");

	for (symCode = 1; symCode < FGRID_SYMS; symCode++) {
		
		/**
		 **	Pack SymEdit's internal data structure into
		 ** buffer and return the number of buffer bytes.
		 ** Write symbol length to file followed by the
		 ** symbol bytes themselves.
		 **
		 **/
		 
 		PackSymbol(symCode, symBuf, &symBytes);

		bytesWritten = fwrite(&symBytes, sizeof(unsigned short), 1, newFile);
		IOCheck(bytesWritten, 1);
	
		bytesWritten = fwrite(*symBuf, 1, symBytes, newFile);
		IOCheck(bytesWritten, symBytes);
		
		printf("Symbol %d packed\n", symCode);
		
	}
	
	fclose(newFile);	

}


main()

{
	symBuf = NewHandle(SYMBUF_SIZE);
	HLock(symBuf);
	
	ReadOld();
	WriteNew();
	
	SysBeep(20);
	
	DisposHandle(symBuf);
	
}