
/*
 *  stdlib.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

#define NULL		((void *) 0)

#define EXIT_SUCCESS			0
#define EXIT_FAILURE			(-1)
#define RAND_MAX				32767
#define MB_CUR_MAX				1

typedef struct { int quot, rem; } div_t;
typedef struct { long quot, rem; } ldiv_t;

#include "size_t.h"
#include "wchar_t.h"

double atof(const char *);
int atoi(const char *);
long atol(const char *);
double strtod(const char *, char **);
long strtol(const char *, char **, int);
unsigned long strtoul(const char *, char **, int);

int rand(void);
void srand(unsigned);

void *calloc(size_t, size_t);
void free(void *);
void *malloc(size_t);
void *realloc(void *, size_t);

void abort(void);
int atexit(void (*)(void));
void exit(int);
char *getenv(const char *);
int system(const char *);

typedef int (*__cmp_func)(const void *, const void *);
void *bsearch(const void *, const void *, size_t, size_t, __cmp_func);
void qsort(void *, size_t, size_t, __cmp_func);

int abs(int);
div_t div(int, int);
long labs(long);
ldiv_t ldiv(long, long);

int mblen(const char *, size_t);
int mbtowc(wchar_t *, const char *, size_t);
int wctomb(char *, wchar_t);

size_t mbstowcs(wchar_t *, const char *, size_t);
size_t wcstombs(char *, const wchar_t *, size_t);

typedef void (*__exit_func)(void);
void _exit(int);
int _atexit(__exit_func);
void _exiting(int);
extern int _abnormal_exit;

typedef int (*__cmp1_func)(size_t, size_t);
typedef void (*__swap1_func)(size_t, size_t);
void _qsort(size_t, __cmp1_func, __swap1_func);
