
/*
 *  time.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

#define CLOCKS_PER_SEC		60

#define NULL		((void *) 0)

typedef unsigned long clock_t;
typedef unsigned long time_t;
#include "size_t.h"

struct tm {
	int				tm_sec;
	int				tm_min;
	int				tm_hour;
	int				tm_mday;
	int				tm_mon;
	int				tm_year;
	int				tm_wday;
	int				tm_yday;
	int				tm_isdst;
};

clock_t clock(void);
double difftime(time_t, time_t);
time_t mktime(struct tm *);
time_t time(time_t *);

char *asctime(const struct tm *);
char *ctime(const time_t *);
struct tm *gmtime(const time_t *);
struct tm *localtime(const time_t *);
size_t strftime(char *, size_t, const char *, const struct tm *);
