
/*
 *  unix.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

#include "stdio.h"

int open(char *, int);
int creat(char *, int);

int fileno(FILE *);
FILE *fdopen(int, char *);

int read(int, char *, unsigned);
int write(int, char *, unsigned);
int close(int);

long lseek(int, long, int);
long tell(int);

int getw(FILE *);
int putw(int, FILE *);

int unlink(char *);
int isatty(int);

extern int __pid, __ppid, __uid, __gid;
#define getpid()		((int) __pid)
#define getpgrp()		((int) __pid)
#define getppid()		((int) __ppid)
#define getuid()		((int) __uid)
#define geteuid()		((int) __uid)
#define getgid()		((int) __gid)
#define getegid()		((int) __gid)

unsigned sleep(unsigned);
int kill(int, int);
char *getlogin(void);

int exec(char *, ...);
#define execl		exec
#define execv		exec
#define execle		exec
#define execve		exec
#define execlp		exec
#define execvp		exec
#define execlpe		exec
#define execvpe		exec
