
/*
 *  bsearch.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdlib.h"


void *
bsearch(const void *key, const void *base, size_t n, size_t size, __cmp_func compare)
{
	register size_t i = 0, j;
	int k;
	void *guess;
	
	while (i < n) {
		j = (i + n - 1) >> 1;
		guess = (char *) base + j * size;
		if ((k = (*compare)(key, guess)) == 0)
			return(guess);
		if (k < 0)
			n = j;
		else
			i = j + 1;
	}
	return(NULL);
}
