
/*
 *  ungetc.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include "stdio.h"
#include "string.h"
#include "ansi_private.h"


int
ungetc(int c, FILE *fp)
{
	size_t n;
	
	if (c == EOF)
		return(EOF);
	__checkfile(fp);
	if (fp->pushed) {
		if (fp->cnt)
			return(EOF);
	}
	else if (fp->cnt == fp->size && fp->size) {
		fp->pos -= fp->cnt;
		fp->cnt = 0;
		fp->ptr = &fp->pushc + 1;
		fp->pushed = 1;
	}
	else if (fp->ptr == (unsigned char *) fp->buf)
		memmove(fp->ptr += fp->size - fp->cnt, fp->buf, fp->cnt);
	fp->eof = 0;
	++fp->cnt;
	return(*--fp->ptr = c);
}
