
/*
 *  unixmisc.c
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#include <MacHeaders>

#include "unix.h"
#include "errno.h"
#include "signal.h"
#include "stdlib.h"
#include "ansi_private.h"

int __pid = 57, __ppid = 5, __uid = 24, __gid = 31;


/*
 *  sleep - delay for "n" seconds
 *
 */

unsigned
sleep(unsigned n)
{
	long m;
	
	Delay(60L * n, &m);
	return(0);
}


/*
 *  kill - send signal to a process
 *
 *  The only valid process is this one.
 *
 */

int
kill(int pid, int sig)
{
	if (pid == getpid() || pid == 0 || pid == -1 || pid == -getpgrp())
		return(sig ? raise(sig) : 0);
	errno = ESRCH;
	return(-1);
}


/*
 *  getlogin - get login name
 *
 *  Use the Chooser to set the login name.
 *
 */

char *
getlogin(void)
{
	static char got_it, buf[33];
	short refnum;
	Handle h;
	
	if (!got_it) {
		refnum = CurResFile();
		UseResFile(0);
		h = GetResource('STR ', -16096);
		UseResFile(refnum);
		if (h) {
			HLock(h);
			sprintf(buf, "%#.*s", (int) sizeof buf - 1, *h);
			HUnlock(h);
		}
		got_it = 1;
	}
	return(buf[0] ? buf : NULL);
}


/*
 *  exec - transfer to another application
 *
 *  This handles all the exec functions.  Arguments, etc., are not
 *  passed to the new task.
 *
 */

int
exec(char *filename, ...)
{
	char pname[FILENAME_MAX];
	static struct { unsigned char *name; long flag; } buf;

	buf.name = __c2p(filename, pname);
	_exiting(1);
	asm {
		lea		buf,a0
		_Launch
		_ExitToShell
	}
}
