/******************************************************************************
 CPopupMenu.h

		Interface for PopupMenu class.
		
	SUPERCLASS = CBureaucrat
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/
 
#define _H_CPopupMenu

#include "CBureaucrat.h"

typedef enum tPMSelectAction	/* modifier passed to SelectItem & SelectItemName */
{
	pmForceOn,		/* check item - only allowed option for single selection menus */
	pmToggle,		/* toggle the item (multiSelect only) */
	pmForceOff		/* uncheck item (multiSelect only */
	
} tPMSelectAction;

class CPopupMenu : public CBureaucrat
{
public:

	void	IPopupMenu( short aMenuID, CBureaucrat *aSupervisor,
					Boolean fAutoSelect, Boolean fMultiSelect);
	virtual void	AppendResNames( ResType aResType);
	virtual void	CheckCmdKey( char theChar, Byte keyCode, EventRecord *macEvent,
					long *theCmd, short *theItem);	
	virtual long	PopupSelect( Point where, long aCmd);
	virtual MenuHandle GetMacMenu( void);
	virtual void	GetTitle( StringPtr aTitle);
	virtual short	GetWidth( void);
		
	virtual short	GetNumItems( void);
	virtual void	GetItemString( short item, StringPtr string);
	virtual long	GetItemCommand( short item);
	virtual short	GetCheckedItem( void);
	virtual void	GetCurrItemString( StringPtr string);
	virtual Boolean ItemIsChecked( short item);

	virtual void	SelectItem( short itemNum,tPMSelectAction actionType);
	virtual void	SelectItemName( StringPtr name, tPMSelectAction actionType);

protected:
	
	MenuHandle	macMenu;		/* handle to menu						*/
	short		menuID;			/* ID of the menu						*/
	long		lastCmd;		/* last command issued					*/
	Boolean		autoSelect;		/* automatically checks items if TRUE	*/
	Boolean		multiSelect;	/* allow multiple checked items if TRUE	*/
	short		firstSelection;	/* first selected menu item number		*/	
	
	virtual void	PreparePopup( void);
	virtual void	CheckMenuItem( short item, Boolean fCheckIt);
};

/* Change protocol for CPopupMenu */

enum
{
			// a new item was selected. Info parameter is
			// a pointer (short*) to the new item number
			
	popupMenuNewSelection = bureaucratLastChange + 1,
	popupMenuLastChange = popupMenuNewSelection
	
};