/******************************************************************************
 CRadioControl.c

		A RadioControl corresponds to a Macintosh radio button. It is 
		typically part of a group, and only one radio button in the
		group may be selected at a time. This behavior will occur
		automatically if the supervisor of the CRadioControl is
		a CRadioGroupPane object.
		
	
	SUPERCLASS = CButton
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "Commands.h"
#include "CRadioControl.h"

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 IRadioControl

		Initialize a RadioControl object
 ******************************************************************************/

void	CRadioControl::IRadioControl(
	short			CNTLid,
	CView			*anEnclosure,
    CBureaucrat     *aSupervisor)
{
	CButton::IButton(CNTLid, anEnclosure, aSupervisor);
}
	
/******************************************************************************
 INewRadioControl
 
 	Create a RadioControl dynamically, rather than from a resource.
******************************************************************************/

void CRadioControl::INewRadioControl( short aWidth, short aHeight, short aHEncl, 
					short aVEncl, StringPtr title, Boolean fVisible,
					CView *anEnclosure, CBureaucrat	*aSupervisor)
{
	CButton::INewButton( aWidth, aHeight, aHEncl, aVEncl, title, fVisible,
				radioButProc, anEnclosure, aSupervisor);

}

/******************************************************************************
 DoGoodClick {OVERRIDE}

		A RadioControl responds to a good click (the mouse being pressed
		and released within the button) by relaying a command to its
		supervisor if it is not already selected. 
 ******************************************************************************/

void	CRadioControl::DoGoodClick(
	short		whichPart)				/* Will always be inButton			*/
{
	if (GetValue() == BUTTON_OFF)
	{
		SetValue( BUTTON_ON);

		if (clickCmd != cmdNull)
			itsSupervisor->DoCommand(clickCmd);
	}
}
	
