/******************************************************************************
 CDirectorOwner.h

		Interface for CDirectorOwner class
		
	SUPERCLASS = CBureacrat
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CDirectorOwner

#include "CBureaucrat.h"

class CDirector;
class CList;

class CDirectorOwner : public CBureaucrat
{
public:

	CList		*itsDirectors;		// list of its directors
	Boolean			active;			// TRUE if any director is active
	
	void IDirectorOwner( CDirectorOwner *aSupervisor);
	
	virtual void AddDirector( CDirector *aDirector);
	virtual void RemoveDirector( CDirector *aDirector);
	
	virtual void ActivateDirector( CDirector *aDirector);
	virtual void DeactivateDirector( CDirector *aDirector);
	
	virtual void Suspend( void);
	virtual void Resume( void);
	
	virtual Boolean Quit( void);
	virtual Boolean Close( Boolean fQuitting);
	
	virtual void Dispose( void);

};