/******************************************************************************
 CPaneBorder.c

		Interface for PaneBorder object
		
	SUPERCLASS = CObject
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define	_H_CPaneBorder

#include "CObject.h"

#define		kBorderNone			0x00
#define		kBorderLeft			0x01
#define		kBorderTop			0x02
#define		kBorderRight		0x04
#define		kBorderBottom		0x08
#define		kBorderFrame		(kBorderLeft+kBorderTop+kBorderRight+kBorderBottom)
#define		kBorderOval			0x10
#define		kBorderRoundRect	0x20
#define		kBorderRsrv1		0x40
#define		kBorderRsrv2		0x80

#define kPaneBorderRes	'PBrd'		// CPaneBorder resource type

class CPaneBorder : public CObject
{
public:

	void IPaneBorder( short borderFlags);
	
	void IResPaneBorder( short resID);

	virtual void SetPattern( Pattern aPattern);
	virtual void GetPattern( Pattern aPattern);
	
	virtual void SetBorderFlags( long aBorderFlags);
	virtual long GetBorderFlags( void);
	
	virtual void SetPenSize( short penWidth, short penHeight);
	virtual void GetPenSize( short *penWidth, short *penHeight);
	
	virtual void SetShadow( short hOffset, short vOffset, short width, short height);
	virtual void GetShadow( short *hOffset, short *vOffset, short *width, short *height);
	
	virtual void SetRounding( short hDiameter, short vDiameter);
	virtual void GetRounding( short *hDiameter, short *vDiameter);
	
	virtual void SetMargin( Rect *aMargin);
	virtual void GetMargin( Rect *aMargin);
	
	virtual void CalcBorderRect( Rect *paneFrame);
	
	virtual void DrawBorder( Rect* paneFrame);

protected:

	long	borderFlags;	/* describes the type of border					*/
	Point	borderPen;		/* pen size for border							*/
	Point	shadowOffset;	/* amount to offset for shadow					*/
	Point	shadowPen;		/* pen size for shadow							*/
	Boolean	doShadow;		/* TRUE if shadow is drawn						*/
	Point	roundDiameter;	/* oval width and height for rounded rectangle	*/
	Pattern penPat;			/* pattern for border							*/
	Rect	margin;			/* minimum whitespace desired					*/
};

#define kPaneBorderRes	'PBrd'		// CPaneBorder resource type

typedef struct		// format of resource template
{
	long 	borderFlags;
	Point	borderPen;
	Point	shadowOffset;
	Point	shadowPen;
	Point	roundDiameter;
	short	patID;
	Rect	margin;
	
} PaneBorderTemp;