/******************************************************************************
 CScrollBar.h

		Interface for the ScrollBar Class
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
 ******************************************************************************/
 
#define _H_CScrollBar

#include "CControl.h"					/* Interface for its superclass		*/

typedef enum {
	HORIZONTAL,
	VERTICAL
} Orientation;

class CScrollBar : public CControl {	/* Class Declaration				*/

public:
								/** Instance Variables **/
	Orientation		theOrientation;		/* Horizontal or Vertical			*/
	VoidFunc		theThumbFunc;		/* Function to call for thumb drag	*/
	
								/** Instance Methods **/
									/** Contruction/Destruction **/
	void			IScrollBar(CView *anEnclosure, CBureaucrat *aSupervisor,
								Orientation anOrientation, short aLength,
								short aHEncl, short aVEncl);

									/** Accessing **/
	virtual void			SetThumbFunc(VoidFunc aThumbFunc);

									/** Drawing **/
	virtual void			Draw(Rect *area);
	virtual void			Activate(void);
	virtual void			Deactivate(void);

									/** Click Response **/
	virtual void			DoClick(Point hitPt, short modifierKeys, long when);
	virtual void			DoThumbDragged(short delta);
	
};