/******************************************************************************
 Constants.h

		Constants used in the THINK Class Library
		
		Copyright  1989 Symantec Corporation. All rights reserved.
		
	TCL 1.1 CHANGES
	[
		- added STRfailMsg, ALRT_Exception
		- added constants for additionial virtual key codes 
	]
		
 ******************************************************************************/
 
#define _H_Constants


#define		STRcommon		128			/* STR# resource ID for commonly	*/
										/*   used strings					*/
#define		strQUITTING		1
#define		strCLOSING		2
#define		strUNDO			3
#define		strREDO			4
#define		strUNTITLED		5
#define		strSHOWCLIP		6
#define		strHIDECLIP		7

#define		STRmemWarn		129			/* Strings for low memory warnings	*/
#define		iMEM_LOW		1

#define		MBARapp			1			/* Menu Bar Resource ID				*/

#define		MINIMUM_BALANCE	2048L		/* Minimum memory reserve			*/

#define		CMD_DELIMITER	'#'			/* Separates item name from cmd no.	*/
#define		DEFAULT_DIM		dimALL		/* Default DimOption for menus		*/

#define		WIND_CLIPBOARD	200			/* Clipboard window resource ID		*/

									/** Button Numbers in Alerts **/
#define		answerYES		1
#define		answerNO		2
#define		answerCANCEL	3

#define		DRAG_MARGIN		4			/* Margin around desktop when		*/
										/*   dragging a window				*/
#define		REASONABLY_CLOSE	5		/* How close two points must be to	*/
										/*   be part of a multi-click on	*/
										/*   the Desktop					*/
										
									/** CDecorator Parameters **/
#define		MAX_WOFFSETS	5			/* Max depth of offsetting windows	*/
#define		LEFT_SMARGIN	4			/* Margin at left of screen			*/
#define		TOP_SMARGIN		22			/* Margin at top of screen			*/
#define		RIGHT_SMARGIN	4			/* Margin at right of screen		*/
#define		BOTTOM_SMARGIN	4			/* Margin at bottom of screen		*/
#define		HORIZ_WOFFSET	8			/* Horizontal window offset			*/
#define		VERT_WOFFSET	16			/* Vertical window offset			*/

#define		STRprompt		150			/* STR resource ID of prompt string	*/
										/*   when doing a SaveAs			*/
#define		ALRTrevert		150			/* Alert to confirm revert to saved	*/
#define		ALRTsaveChanges	151			/* Save changes before close/quit	*/
#define		STRtaskNames	130			/* STR# resource ID for task names	*/
#define		STR_TCLfailMsgs	131			/* STR# resource ID for failure 	*/
										/* messages	for TCL					*/
#define		kUserFailMsgBase 1024		/* programmer defined failure 		*/
										/* are specified from a base value 	*/
										/* of 1024							*/
#define		STRdlgValidation 133		/* STR# resource ID for dialog		*/
										/* validation errors				*/

#define		ALRTgeneral		128			/* Generic Alert box				*/
#define		ALRTvalidation	129			/* Alert box for dialog validation  */
#define		ALRTsevereErr	200			/* Alert box for a Severe Error		*/
#define		ALRTosError		300			/* Alert box for a Mac OS Error		*/
#define		ALRT_NOPRINTER	250			/* Alert when there is no printer	*/
#define		ALRT_Exception	251			/* Alert used by exception handler  */
#define		ALRT_ExceptionAbort 252		/* Exception alert used when aborting app */
#define		STRosError		300			/* Generic Mac OS error message		*/
#define		STRosError2		301			/* ErrorAlert's Mac OS error message		*/
#define		ErrMsg_Res		'Estr'		/* Resource type for list of error	*/
										/*   message string corresponding	*/
										/*   to Mac OS Errors/result codes	*/
#define		kDefaultHelpResID	128		/* default ID for 'hrct' help		*/
										/* balloon resource					*/

#define		CNTL_SBAR		300			/* CNTL Resource ID of a scroll bar	*/

#define		PAGE_DELAY		10			/* Ticks to delay during continuous	*/
										/*   page scrolling					*/
										
#define		SIZEBOX_LENGTH	16			/* Length of a size box in pixels	*/
#define		SICN_SIZEBOX	200			/* SICN Resource ID for size box	*/

#define		TCL_SICN		200			/* resource ID for SICN used by TCL	*/
#define		POPUP_SICN		2			/* index into SICN 200 for popup arrow */

#define		MIN_WSIZE		100			/* Minimum size of a window			*/

#define		SBARSIZE		16			/* Size of a scroll bar in pixels	*/
#define		SBARSIZE1		15			/* SBARSIZE - 1						*/

#define		OBJ_WINDOW_KIND	1001		/* windowKind for a Mac window		*/
										/* associated with a CWindow object	*/
										
#define		STD_PAGE_WIDTH	576			/* Default pixel width of a page	*/
#define		STD_PAGE_HEIGHT	720			/* Default pixel height of a page	*/

#define		SYS_FONT_SIZE	12			/* Size of System font				*/

#define		kEnterKey		3			/* ASCII code for Enter key			*/
#define		kEscapeOrClear	0x1B		/* ASCII code for both Escape and Clear keys */
#define 	kLeftCursor		28
#define 	kRightCursor	29
#define 	kUpCursor		30
#define 	kDownCursor	 	31

#define     KeyHome         0x73        /* Key code for Home key            */
#define     KeyEnd          0x77        /* Key code for End key             */
#define     KeyPageUp       0x74        /* Key code for Page Up key         */
#define     KeyPageDown     0x79        /* Key code for Page Down key       */
#define		KeyEscape		0x35		/* Key code for Escape key			*/
#define		KeyClear		0x47		/* Key code for Clear key			*/
#define		KeyHelp			0x72		/* Key code for Help key			*/
#define		KeyFwdDelete	0x75		/* Key code for Forward Delete		*/
#define		KeyLeftCursor	0x7B		/* Key code for cursor left			*/
#define		KeyRightCursor	0x7C		/* Key code for cursor right		*/
#define		KeyUpCursor		0x7E		/* Key code for cursor up			*/
#define		KeyDownCursor	0x7D		/* Key code for cursor down			*/
#define		KeyF1			0x7A		/* Key code for F1					*/
#define		KeyF2			0x78		/* Key code for F2					*/
#define		KeyF3			0x63		/* Key code for F3					*/
#define		KeyF4			0x76		/* Key code for F4					*/
#define		KeyF5			0x60		/* Key code for F5					*/
#define		KeyF6			0x61		/* Key code for F6					*/
#define		KeyF7			0x62		/* Key code for F7					*/
#define		KeyF8			0x64		/* Key code for F8					*/
#define		KeyF9			0x65		/* Key code for F9					*/
#define		KeyF10			0x6D		/* Key code for F10					*/
#define		KeyF11			0x67		/* Key code for F11					*/
#define		KeyF12			0x6F		/* Key code for F12					*/
#define		KeyF13			0x69		/* Key code for F13					*/
#define		KeyF14			0x6B		/* Key code for F14					*/
#define		KeyF15			0x71		/* Key code for F15					*/