/******************************************************************************
 CMouseTask.c

							The MouseTask Class
		
	SUPERCLASS = CTask
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CMouseTask.h"
#include "LongCoordinates.h"

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/


/******************************************************************************
 IMouseTask

		Initialize a MouseTask object
 ******************************************************************************/

void	CMouseTask::IMouseTask(
	short		aNameIndex)
{
	CTask::ITask(aNameIndex);
}


/**** M O U S E   T R A C K I N G   M E T H O D S ****/


/******************************************************************************
 BeginTracking

		Mouse down tracking is about to begin at the specified starting
		point. Subclasses should override this method if they wish to
		perform preparations before tracking or to alter the startPt
		(startPt could be altered to implement "snap to grid" for a
		drawing program).
 ******************************************************************************/

void	CMouseTask::BeginTracking(
	LongPt		*startPt)
{
}										/* Null Method						*/


/******************************************************************************
 KeepTracking

		Continuous mouse tracking while the mouse button is down. The
		current, previous, and starting mouse locations are passed by
		reference so the method may change their values. For example,
		the values may be changed to implement constrained drawing.
 ******************************************************************************/

void	CMouseTask::KeepTracking(
	LongPt		*currPt,
	LongPt		*prevPt,
	LongPt		*startPt)
{
}										/* Null Method						*/


/******************************************************************************
 EndTracking

		Mouse down tracking has ended because the user has released the
		mouse button.
 ******************************************************************************/

void	CMouseTask::EndTracking(
	LongPt		*currPt,
	LongPt		*prevPt,
	LongPt		*startPt)
{
}										/* Null Method						*/

