/******************************************************************************
 CTask.c

							The Task Class
		
	SUPERCLASS = CObject
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CTask.h"


/******************************************************************************
 ITask

		Initialize a Task
 ******************************************************************************/

void	CTask::ITask(
	short		aNameIndex)
{
	nameIndex = aNameIndex;
	undone = FALSE;
}


/******************************************************************************
 GetNameIndex

		Return the index in the Task name string list
 ******************************************************************************/

short	CTask::GetNameIndex()
{
	return(nameIndex);
}


/******************************************************************************
 Do

		Perform a Task
 ******************************************************************************/

void	CTask::Do()
{
}


/******************************************************************************
 Undo

		Undo a task. Subclasses must override this method.
 ******************************************************************************/

void	CTask::Undo()
{
	undone = !undone;
}


/******************************************************************************
 Redo

		Redo a task which has been undone. This method assumes that Redo
		is the same as Undo. Subclasses which implement Redo differently
		from Undo must override this method.
 ******************************************************************************/

void	CTask::Redo()
{
	Undo();
}

/******************************************************************************
 IsUndone

		Return instance variable
 ******************************************************************************/

Boolean	CTask::IsUndone()
{
	return undone;
}

