/******************************************************************************
 CDialog.h

		Interface for Dialog class
		
	SUPERCLASS = CWindow
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CDialog

#include "CWindow.h"

class CDesktop;
class CDirector;
class CButton;
class CPane;
class CPanorama;

	// structure used by FindGophers to locate eligible gophers
	
typedef struct tGopherInfo
{
	CView *currentGopher;
	Boolean hitCurrent;
	CView *firstGopher;
	CView *lastGopher;
	CView *nextGopher;
	CView *prevGopher;

} tGopherInfo;

#define	kDialogPanoramaID	'pano'		// view ID of dialog panorama
#define kDialogScrollPaneID	'scpn'		// view ID of dialog scroll pane, if any


class CDialog : public CWindow
{
public:

	void		IDialog(short WINDid, CDesktop *anEnclosure, CDirector *aSupervisor);
	void		INewDialog( Rect *bounds, Boolean fVisible, short procID, Boolean fHasGoAway,
						CDesktop *anEnclosure, CDirector *aSupervisor);
	void		IDialogX(void);
						
	virtual void 	DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	virtual void 	DoTab( Boolean fForward);
	
	virtual void 	FindGophers( tGopherInfo *gopherInfo);
	virtual CButton *FindButton( long aCmd);
	
	virtual void 	SetCmdEnable( long aCmd, Boolean fEnable);
	virtual void 	SetDefaultCmd( long aCmd);
	virtual void 	SetDefaultButton( CButton *aButton);
		
	virtual void 	ScrollToPane( CPane *aPane);
	
	virtual void 	Close(void);
	virtual Boolean Validate( void);	

	virtual void 	ProviderChanged( CCollaborator *aProvider, long reason, void* info);

protected:

	CButton 		*defaultBtn;		// current default button
	CPanorama		*itsPanorama;		// panorama that encloses all dialog items
	Boolean			scrollable;			// TRUE if autoscrolling is enabled. This
										// is the case when itsPanorama is enclosed
										// in a scroll pane.
	
	virtual void 	MakePanorama( Boolean fHasHScroll, Boolean fHasVScroll, Boolean fHasSizeBox);
				  

};

