/******************************************************************************
 CIntegerText.h

		Interface for CIntegerText class
		
	SUPERCLASS = CDialogText
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#define _H_CIntegerText

#include "CDialogText.h"

class CIntegerText : public CDialogText
{
public:

	void 	IIntegerText( CView *anEnclosure, CView *aSupervisor,
					short aWidth, short aHeight,
					short aHEncl, short aVEncl,
					SizingOption aHSizing, SizingOption aVSizing,
					short aLineWidth);
					
	virtual void 	IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
							Ptr viewData);
	virtual void	SpecifyRange( long aMinimum, long aMaximum);
	virtual void	SpecifyDefaultValue( long aDefaultValue);
	
	virtual void	SetIntValue( long aValue);
	virtual long	GetIntValue( void);	

	virtual Boolean Validate( void);	

protected:

	long 	minValue;		// minimum valid value
	long 	maxValue;		// maximum valid value
	long	defaultValue;	// default value if text empty. If 
							// CDialogText::isRequired is FALSE, then
							// empty text is considered valid and default
							// value is returned by GetIntValue.
	Boolean showRangeOnErr; // If TRUE, validation error displays allow
							// range of integers in the alert
							
	virtual void ConvertToInteger( long *intValue, Boolean *valid);
};

	// indices into validation error STR# resource for CInteger text

#define		validateIntFailed		3	// text not integer or out of range
#define		validateIntRangeFailed	4	// same, but display allowed range in alert

typedef struct tIntegerTextTemp
{
	tDialogTextTemp dlgTextTmp;
	long			 minValue;
	long			 maxValue;
	long			 defaultValue;
	short			 showRangeOnErr;
	
} tIntegerTextTemp, *tIntegerTextTempP;