/******************************************************************************
 CTearChore.c

							The TearChore Class
		
	Chore for notifying a tear-off menu object that its associated menu has
	been torn off.
	
	SUPERCLASS = CChore
	
	Copyright  1989 Symantec Corporation. All rights reserved.

 ******************************************************************************/

#include "Global.h"
#include "CTearChore.h"
	

/******************************************************************************
 ITearChore

		Initialize a TearChore object
 ******************************************************************************/

void	CTearChore::ITearChore(
	CTearOffMenu	*aTearOffMenu)		/* TearOffMenu Director				*/
{
	itsTearOffMenu = aTearOffMenu;		/* Store object reference			*/
}
	

/******************************************************************************
 Perform {OVERRIDE}

		Carry out chore by telling a TearOffMenu to move its window in
		response to its menu being torn off
 ******************************************************************************/

void	CTearChore::Perform(
	long	*maxSleep)
{
	itsTearOffMenu->MoveToCorner();
}
