
/*
 *  new_by_name.c - instantiation by name
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#define OOPS_PRIVATE
#include "oops.h"

extern void *__new_direct(...);
extern void *__new_indirect(...);


/*
 *  new_by_name - create an object given the name of its class
 *
 */

void *
new_by_name(char *name)
{
	struct { void *min, *max; } range;
	register void *p, *q;

	asm {

;;
;
;  establish search range
;
;;

#if __option(a4_globals)
		movea.l	a4,a0
		_RecoverHandle
		_GetHandleSize
		move.l	a4,range.min
		add.l	a4,d0
		move.l	d0,range.max
#else
		move.l	CurStackBase,range.min
		move.l	a5,range.max
#endif

;;
;
;  search data area for matching name (this could probably be improved)
;
;;

		movea.l	range.min,p
		movea.l	name,q
		move.w	(q)+,d1					;  D1.W = 1st two bytes of name
@1		cmp.w	(p)+,d1
		beq.s	@2
		cmpa.l	range.max,p
		blo.s	@1
;
		moveq	#0,d0					;  search failed
		return
;
@2		movea.l	p,a0
		movea.l	q,a1
		bra.s	@4
@3		cmpm.b	(a0)+,(a1)+
		bne.s	@1						;  name not found - keep looking
@4		tst.b	-1(a1)
		bne.s	@3

;;
;
;  verify we've found a class info record
;
;;

		moveq	#~1,d0
		and.w	-4(p),d0
		lea		-4(p,d0.w),a0			;  A0 ==> dispatch table
		cmpa.l	range.min,a0
		blo.s	@1						;  out of range - try again
		cmpa.l	range.max,a0
		bhs.s	@1						;  out of range - try again
;
		moveq	#1,d0
		add.w	(a0),d0
		lsl.w	#DSHIFT,d0
		lea		ClassInfo_(name[2])+2(a0,d0.w),a1
		cmpa.l	p,a1
		bne.s	@1						;  sanity check failed - try again

;;
;
;  create object
;
;;

		move.l	a0,-(sp)
		btst	#0,-3(p)
		bne.s	@5
		jsr		__new_direct
		bra.s	@6
@5		jsr		__new_indirect
@6		addq.l	#4,sp
	}
}


/*
 *  __class_name - get the name of an object's class
 *
 */

char *
__class_name()
{
	asm {
		movea._	4(sp),a0
	#ifdef BASE_REG
		adda.l	BASE_REG,a0				;  A0 ==> dispatch table
	#endif
		moveq	#1,d0
		add.w	(a0)+,d0
		lsl.w	#DSHIFT,d0
		adda.w	d0,a0					;  A0 ==> class info
		moveq	#ClassInfo_(name),d0
		add.l	a0,d0					;  D0 ==> class name
	}
}
